"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportedVariantQuestionnaireRD(ProtocolElement):
    """
    This object holds all questionnaire questions together with normalized
    variant coordinates.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "reportEvent",
        "variantCoordinates",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import cva as cva_1_5_3
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "reportEvent": cva_1_5_3.ReportEventQuestionnaireRD,
            "variantCoordinates": reports_6_9_0.VariantCoordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import cva as cva_1_5_3
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "org.gel.models.cva.avro.ReportEventQuestionnaireRD": cva_1_5_3.ReportEventQuestionnaireRD,
            "org.gel.models.report.avro.VariantCoordinates": reports_6_9_0.VariantCoordinates,
            "org.gel.models.cva.avro.ReportedVariantQuestionnaireRD": cva_1_5_3.ReportedVariantQuestionnaireRD,
        }

    __slots__ = [
        "reportEvent",
        "variantCoordinates",
    ]

    def __init__(
        self,
        reportEvent,
        variantCoordinates,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.ReportedVariantQuestionnaireRD model.

        :param reportEvent:
            The questionnaire report event
        :type reportEvent: ReportEventQuestionnaireRD
        :param variantCoordinates:
            The normalized representation of variants coordinates
        :type variantCoordinates: VariantCoordinates
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
